//+------------------------------------------------------------------+
//|                                           StochasticDiNapoli.mq4 |
//|                                      Copyright  2010, LenIFCHIK |
//|     ,    |
//|  "    ".        |
//|      ,   |
//|       ,      |
//|  (    "//"). |
//|           |
//| "//".                                                     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LenIFCHIK"

#property indicator_separate_window       //  
#property indicator_minimum 0             // 
#property indicator_maximum 100           // 

#property indicator_buffers 2             //  
#property indicator_color1 RoyalBlue      //  %K
#property indicator_color2 FireBrick      //  %D
//----  
extern int FastK=8;                       //  %K
extern int SlowK=3;                       // "" %K
extern int SlowD=3;                       // "" %D
extern string Levels_display_mode="0 - off, 1 - on";
extern int Levels_ON_OFF=0;               //   /
extern int OBLevel=80;                    //  (   )
extern int OSLevel=20;                    //  (   ) 
//----  
double StoBuffer[];                       //  
double SigBuffer[];                       //  
//+------------------------------------------------------------------+
//| .  Init                                      |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//----  
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); //  
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1); //  
//----     
   SetIndexBuffer(0,StoBuffer);
   SetIndexBuffer(1,SigBuffer);
//----      
   short_name="Stochastic DiNapoli("+FastK+","+SlowK+","+SlowD+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Stoch");
   SetIndexLabel(1,"Signal");
//----  
   SetIndexDrawBegin(0,FastK);
   SetIndexDrawBegin(1,FastK);
//----      
   switch(Levels_ON_OFF)                     //   /
     {
     case 0 :                                //
       SetLevelValue(1,EMPTY_VALUE);         //  
       SetLevelValue(2,EMPTY_VALUE);         //   
       break;
     case 1 :                                //
       SetLevelValue(1,OBLevel);             //  
       SetLevelValue(2,OSLevel);             //  
//----   
       SetLevelStyle(STYLE_DOT,1,Silver);      
       break;
     default :
       Levels_ON_OFF=0;                      //   
     }
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Stochastic  DiNapoli                                           |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
   double high,low;
//----
   if(Bars<=FastK) return(0);
//---- 
   if(counted_bars<1)
      for(i=1;i<=FastK;i++) 
      {StoBuffer[Bars-i]=0.0;SigBuffer[Bars-i]=0.0;}
//----
   i=Bars-FastK-1;
   if(counted_bars>=FastK) i=Bars-counted_bars-1;
   while(i>=0)
   {
       low=Low[Lowest(NULL,0,MODE_LOW,FastK,i)];                        // 
       high=High[Highest(NULL,0,MODE_HIGH,FastK,i)];                    //     
       double Fast=(Close[i]-low)/(high-low)*100;                       //    %
       StoBuffer[i]=StoBuffer[i+1]+(Fast-StoBuffer[i+1])/SlowK;         //  
       SigBuffer[i]=SigBuffer[i+1]+(StoBuffer[i]-SigBuffer[i+1])/SlowD; //  
   i--;
   }
   return(0);
  }
//+------------------------------------------------------------------+